#include "stdafx.h"
#include "myListView.h"
#include "stdio.h"

/* *****************************************************************************
***************************************************************************** */

LRESULT MyCallWindowProc (CMyListView *listView,HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

// ***************************************************************************************

LRESULT CALLBACK ListViewParentCallBack (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	CMyListView *listView = (CMyListView *) GetWindowLong(hDlg,DWL_USER);
	if (!listView) return FALSE; // WM_DESTROY
/*	CMyString temp;
	temp <<"LISTVIEW:CallBack hWnd:"<<(long)hDlg<<" listView:"<<(long)listView<<" message:"<<(long)message<<"\n";
	OutputDebugString(temp);*/

//	SetWindowLong (hDlg, DWL_USER , (long)listView->m_oldGwlUserDataParent);
//	SetWindowLong (hDlg, DWL_DLGPROC,(long)listView->m_oldCallBackParent);

	switch (message)
	{/*
		case WM_INITDIALOG:
			return MyCallWindowProc(listView,hDlg,message,wParam,listView->m_oldGwlUserDataParent);
*/
		case WM_NOTIFY:
			if (GetDlgItem(hDlg,wParam)==listView->GetHWND())
			{
				ENotify res;
				res = listView->Notify(lParam);	
				if (res!=nothing) MyCallWindowProc(listView,hDlg,WM_COMMAND,wParam,res);
				return TRUE;
			}
			break;
	}
	//return TRUE;
	return MyCallWindowProc(listView,hDlg,message,wParam,lParam);
}

// ***************************************************************************************

LRESULT MyCallWindowProc (CMyListView *listView,HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	listView->m_oldGwlUserDataParent = SetWindowLong (hDlg,DWL_USER,(long)listView->m_oldGwlUserDataParent);
	LRESULT res = CallWindowProc(listView->m_oldCallBackParent,hDlg,message,wParam,lParam);
	listView->m_oldGwlUserDataParent = SetWindowLong (hDlg,DWL_USER,(long)listView);
//	listView->m_oldCallBackParent = (WNDPROC) SetWindowLong (hDlg,DWL_DLGPROC,(long)ListViewParentCallBack);
/*
	CMyString temp;
	temp <<"LISTVIEW:CallWindow hWnd:"<<(long)hDlg<<" m_oldGwlUserDataParent:"<<(long)listView->m_oldGwlUserDataParent<<"\n";
	OutputDebugString(temp);*/
	return res ;
}

/* *****************************************************************************
***************************************************************************** */

void CMyListView::Init()
{
	ListView_SetExtendedListViewStyle(m_hWndControl,ListView_GetExtendedListViewStyle(m_hWndControl) | LVS_EX_FULLROWSELECT);

	m_oldGwlUserDataParent = SetWindowLong(GetParent(),DWL_USER,(long)this);
	m_oldCallBackParent = (WNDPROC) SetWindowLong(GetParent(),DWL_DLGPROC,(long)ListViewParentCallBack); 
}

/* *****************************************************************************
***************************************************************************** */

CMyListView::CMyListView (HWND hwndListView)
: CMyControl(hwndListView)
{
	m_hInst = 0;
	m_nbColumn = 0;
	m_line = 0;
	m_column = 0;
	m_lineSelected = 0;
	m_columnSelected = 0;
	Init();
}

/* *****************************************************************************
***************************************************************************** */

CMyListView::CMyListView(HINSTANCE hInstance,HWND hwndMaster,int x,int y,int dx,int dy) 
: CMyControl(hwndMaster)
{
	m_hInst = hInstance;
	m_nbColumn = 0;
	m_line = 0;
	m_column = 0;
	m_lineSelected = 0;
	m_columnSelected = 0;
	InitCommonControls();
	
	DWORD dwStyle = WS_TABSTOP | WS_CHILD | WS_BORDER | WS_VISIBLE |LVS_AUTOARRANGE |LVS_REPORT | LVS_OWNERDATA | LVS_EX_FULLROWSELECT;
	m_hWndControl = CreateWindowEx( 
		WS_EX_CLIENTEDGE,WC_LISTVIEW,"",dwStyle,
		x,y,dx,dy,
		GetParent(),NULL,m_hInst,NULL);

	if(m_hWndControl) ListView_DeleteAllItems(m_hWndControl);  
	Init();
}

/* *****************************************************************************
***************************************************************************** */

CMyListView::~CMyListView()
{
	DestroyWindow(m_hWndControl);
}

/* *****************************************************************************
***************************************************************************** */

BOOL CMyListView::AddColumnPercent (char *nameHead,double percent)
{
	RECT rect;
	GetClientRect(m_hWndControl,&rect);
	return AddColumn(nameHead,(int)(rect.right*percent));
}

/* *****************************************************************************
***************************************************************************** */

void CMyListView::SetHeight(int deltaY)
{
	//ListBox_SetItemHeight(m_hWndControl,0,deltaY);
}

/* *****************************************************************************
***************************************************************************** */

BOOL CMyListView::AddColumn (char *nameHead,int size)
{
	LV_COLUMN   lvColumn;

	//initialize the columns
	lvColumn.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvColumn.fmt = LVCFMT_LEFT;
	lvColumn.cx = size;
	lvColumn.pszText = nameHead;
	ListView_InsertColumn(m_hWndControl, m_nbColumn++, &lvColumn);
	return TRUE;
}

BOOL CMyListView::SetColumn	(long index,char *nameHead)
{
	LV_COLUMN   lvColumn;

	//initialize the columns
	lvColumn.mask = LVCF_FMT | LVCF_TEXT | LVCF_SUBITEM;
	lvColumn.fmt = LVCFMT_LEFT;
	lvColumn.pszText = nameHead;
	ListView_SetColumn(m_hWndControl, index, &lvColumn);
	return TRUE;

}

/* *****************************************************************************
***************************************************************************** */

void CMyListView::SetGridLinesView(BOOL active)
{
	ListView_SetExtendedListViewStyleEx(m_hWndControl,LVS_EX_GRIDLINES,active?LVS_EX_GRIDLINES:0); 
}


/* *****************************************************************************
***************************************************************************** */

void CMyListView::SetNbCount(int nbCountx)
{
	m_nbCount = nbCountx;
	ListView_SetItemCount(m_hWndControl, m_nbCount);
}

void CMyListView::IncCount ()
{
	SetNbCount(m_nbCount+1);
}

void CMyListView::DecCount ()
{
	SetNbCount(m_nbCount-1);
}


/* *************************************************************************
	interprete le message WM_NOTIFY de la callback mere du ListCtrl:

	getDispInfo     iItem iSubItem; 
	itemChanged		iItem

	char temp[128];
	CMyListView list;

	ENotify res = list.Notify(lParam);
	switch (res)
	{
		case getDispInfo:
			sprintf(temp, "On demande les infos concernant: ligne %d - colone %d", list.GetLine , list.GetColumn);
			list.SetItemText(temp);
			break;

		case itemChanged:
			sprintf(temp,"ligne: %d colone %d",list.GetLineSelected ,list.GetColumnSelected);
			MessageBox(NULL,temp,"Nouvelle selection:",0);
			break;
	}
************************************************************************* */

ENotify CMyListView::Notify (LPARAM lParam)
{
	LPNMHDR lpnmh = (LPNMHDR) lParam;
	if (lpnmh->hwndFrom != m_hWndControl) return nothing;

	switch (lpnmh->code)
	{
		case LVN_GETDISPINFO:
			{
				LV_DISPINFO *lpdi = (LV_DISPINFO *)lParam;
				m_line = lpdi->item.iItem;
				m_column = lpdi->item.iSubItem;
				m_itemText = lpdi->item.pszText;
				return lpdi->item.mask & LVIF_TEXT ? getDispInfo : nothing;
			}
			break;

		case LVN_ITEMCHANGED:
			{
				LPNMLISTVIEW lpnmlist = (LPNMLISTVIEW ) lParam;
				m_lineSelected =  lpnmlist->iItem;
				m_columnSelected = lpnmlist->iSubItem;
				return itemChanged;
			}
//			sprintf(temp,"List View: %d (ItemChanged)\n",lpnmh->code);
//			OutputDebugString(temp);
			break;

		case -12: // changement de la taille d'un colone
			return columnSizeChanged;
	/*		
		default:
			sprintf(temp,"List View: %d (%d)\n ",lpnmh->code,LVN_FIRST);
			OutputDebugString(temp);
	*/

	}
	return nothing;
}


/* *************************************************************************
************************************************************************* */

void CMyListView::Refresh ()
{
	InvalidateRect(m_hWndControl,NULL,TRUE);
}


/* *************************************************************************
************************************************************************* */

int	CMyListView::GetLine()
{
	return m_line;
}


/* *************************************************************************
************************************************************************* */

int	CMyListView::GetColumn()
{
	return m_column;
}


/* *************************************************************************
************************************************************************* */

int	CMyListView::GetLineSelected()
{
	return m_lineSelected;
}


/* *************************************************************************
************************************************************************* */

int	CMyListView::GetColumnSelected()
{
	return m_columnSelected;
}


/* *************************************************************************
************************************************************************* */

void CMyListView::SetItemText(char *text)
{
	if (text) strcpy (m_itemText,text);
}


/* *************************************************************************
************************************************************************* */


int CMyListView::GetColumnWidth(int index)
{
	return ListView_GetColumnWidth(m_hWndControl,index);
}

/* *************************************************************************
************************************************************************* */

BOOL CMyListView::SetImageList (HIMAGELIST himl)
{
	return (BOOL)ListView_SetImageList(m_hWndControl,himl,LVSIL_SMALL);
}


