// listView.h: interface for the CMyListView class.
//
//////////////////////////////////////////////////////////////////////
#include <commctrl.h>

#if !defined(AFX_LISTVIEW_H__E03DD901_8FF2_11D5_9AB9_00D04C390250__INCLUDED_)
#define AFX_LISTVIEW_H__E03DD901_8FF2_11D5_9AB9_00D04C390250__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// type valeur de retour de la fonction Notify
typedef enum
{
	nothing = 0 , getDispInfo  , itemChanged , columnSizeChanged
} ENotify;

/* **********************************************************************************
	Ajouter la comctl32.lib dans les link
********************************************************************************** */

#include "myControl.h"
class CMyListView : public CMyControl
{
	public:
		CMyListView			(HINSTANCE hInstance,HWND hwndMaster,int x,int y,int xy,int dy);
		CMyListView			(HWND hwndListView);
		virtual ~CMyListView();

		BOOL	 AddColumn			(char *nameHead,int size);
		BOOL	 AddColumnPercent   (char *nameHead,double percent);
		void	 SetNbCount			(int nbCount);
		void	 IncCount			();
		void	 DecCount			();
		void	 Refresh			();

		int		 GetLine			();
		int		 GetColumn			();
		int		 GetLineSelected	();
		int		 GetColumnSelected	();
		int		 GetColumnWidth		(int index);
		void	 SetHeight			(int deltaY);
		BOOL	 SetColumn			(long index,char *text);

		void	 SetItemText		(char *text);
		void	 SetGridLinesView	(BOOL active);
		BOOL	 SetImageList		(HIMAGELIST hil);

		ENotify  Notify				(LPARAM lParam);

		// concernant l'ancienne call back
		WNDPROC		m_oldCallBackParent;
		long		m_oldGwlUserDataParent;

	private:
		void		Init();

		int			m_nbCount;
		HINSTANCE	m_hInst;
		int			m_nbColumn;

		int			m_line;
		int			m_column;
		int			m_lineSelected;
		int			m_columnSelected;
		char *		m_itemText;
};

#endif // !defined(AFX_LISTVIEW_H__E03DD901_8FF2_11D5_9AB9_00D04C390250__INCLUDED_)
