#include "stdafx.h"
#include <stdio.h>
#include <windows.h>
#include "MyRegistre.h"

/* ---------------------------------------------------------------------------------------------
   Constructeur du gestionaire de registre (dans "Software")
--------------------------------------------------------------------------------------------- */

CMyRegistre::CMyRegistre(char *xnameKey)
{
	nameKey = xnameKey;
	pathKey = "Software";
	Init();
}

// *************************************************************************************

CMyRegistre::CMyRegistre(char *xpathKey,char *xnameKey)
{
	nameKey = xnameKey;
	pathKey = xpathKey;
	Init();
}

// *************************************************************************************

CMyRegistre::~CMyRegistre()
{
}

// *************************************************************************************

/* ---------------------------------------------------------------------------------------------
   Initialisation: cree une clef pour le nom: nameKey donnee 
--------------------------------------------------------------------------------------------- */

void CMyRegistre::Init()
{
	HKEY hKey ,hKeySub; 

	if (RegOpenKeyExA( HKEY_CURRENT_USER, pathKey , 0 , KEY_WRITE, &hKey)!=ERROR_SUCCESS) 
		::MessageBoxA(0,"Read operation from register key impossible","Error / Register",MB_OK);
	
	if (RegCreateKeyA( hKey, nameKey ,&hKeySub) != ERROR_SUCCESS)	
		::MessageBoxA(0,"Write operation to register key impossible","Error / Register",MB_OK);
		
	RegCloseKey (hKey) ;
}

/* ---------------------------------------------------------------------------------------------
   Donne la valeur du param dans la base de registre ==> result
--------------------------------------------------------------------------------------------- */

int CMyRegistre::GetValue(char *param, CMyString &result)
{
	result.Resize(4096);
	int ret = GetValue(param,result.value);
	result.Resize();
	return ret;
}

// *************************************************************************************

int CMyRegistre::GetValue(char *param , char *result)
{
	HKEY hKey ; 
	DWORD dwSize=MAX_REGISTRY_SIZE;
	ULONG uType = REG_SZ ;
	CMyString path;
	path <<pathKey<<'\\'<<nameKey;

	if (RegOpenKeyExA( HKEY_CURRENT_USER, path,0,KEY_QUERY_VALUE,&hKey) != ERROR_SUCCESS) return FALSE;

	if (RegQueryValueExA (hKey, param,NULL, &uType, (unsigned char *)result, &dwSize) != ERROR_SUCCESS) return FALSE;
	RegCloseKey (hKey) ;
	return TRUE;
}

// *************************************************************************************

int CMyRegistre::GetValue(char *param,long *result)
{
	HKEY hKey ; 
	DWORD dwSize=sizeof(REG_DWORD);
	ULONG uType = REG_DWORD;;
	CMyString path;
	int val;
	path <<pathKey<<'\\'<<nameKey;

	if (RegOpenKeyExA( HKEY_CURRENT_USER, path,0,KEY_QUERY_VALUE ,&hKey) != ERROR_SUCCESS) return FALSE;
	if (val= RegQueryValueExA (hKey, param,NULL, &uType, (unsigned char *)result, &dwSize) != ERROR_SUCCESS) return FALSE;
	
	RegCloseKey (hKey) ;
	return TRUE;
}

/* ---------------------------------------------------------------------------------------------
   Place la valeur value dans le parametre param de la base de registre selectionner par nameKey
--------------------------------------------------------------------------------------------- */

int CMyRegistre::SetValue(char *param,char *value)
{
	HKEY hKey ; 
	CMyString path;
	path <<pathKey<<'\\'<<nameKey;
	
	if (RegOpenKeyExA  (HKEY_CURRENT_USER, path,0,KEY_SET_VALUE,&hKey) != ERROR_SUCCESS) return FALSE;
    if (RegSetValueExA (hKey, param,NULL, REG_SZ , (unsigned char *)value, strlen(value)) != ERROR_SUCCESS) return FALSE;
	RegCloseKey (hKey) ;
	return TRUE;
}

// *************************************************************************************

int CMyRegistre::SetValue(char *param,long value)
{
	HKEY hKey ; 
	CMyString path;
	path <<pathKey<<'\\'<<nameKey;
	
	if (RegOpenKeyExA( HKEY_CURRENT_USER, path,0,KEY_SET_VALUE,&hKey) != ERROR_SUCCESS) return FALSE;
    if (RegSetValueExA (hKey, param,NULL, REG_DWORD , (unsigned char *)&value, sizeof(REG_DWORD)) != ERROR_SUCCESS) return FALSE;
	RegCloseKey (hKey) ;
	return TRUE;
}

// *************************************************************************************

void CMyRegistre::BeginEnumKey ()
{
	m_numEnumKey = 0;
}

// *************************************************************************************

int CMyRegistre::NextEnumKey(char *result)
{
	HKEY hKey ; 
	CMyString path;
	path <<pathKey<<'\\'<<nameKey;
	
	if (RegOpenKeyExA( HKEY_CURRENT_USER, path,0,KEY_READ,&hKey) != ERROR_SUCCESS) return FALSE;
	if (RegEnumKeyA(hKey,m_numEnumKey++,result,MAX_REGISTRY_SIZE) != ERROR_SUCCESS) return FALSE;

	return TRUE;
}

// *************************************************************************************

void CMyRegistre::BeginEnumValue ()
{
	m_numEnumValue = 0;
}

// *************************************************************************************

int CMyRegistre::NextEnumValue (char *result)
{
	HKEY hKey ; 
	DWORD size = MAX_REGISTRY_SIZE;
	DWORD type;
	CMyString path;
	path <<pathKey<<'\\'<<nameKey;
	
	if (RegOpenKeyExA( HKEY_CURRENT_USER, path,0,KEY_READ,&hKey) != ERROR_SUCCESS) return FALSE;
	if (RegEnumValueA(hKey,m_numEnumValue++,result,&size,NULL,&type,NULL,NULL) != ERROR_SUCCESS) return FALSE;
	
	return TRUE;
}

// *************************************************************************************

