#include "stdafx.h"
#include <stdio.h>
#include <string.h>
#include <windows.h>
#include <stdlib.h> 
#include <math.h>

#include "myString.h"
#include "myException.h"

// *********************************************************************************

CMyString::CMyString()
{
	isOwnerBuffer = FALSE;
	size = 0;
	allocSize = 0;
	value = NULL;
}

CMyString::CMyString(char letter)
{
	isOwnerBuffer = FALSE;
	value = NULL;
	*this=letter;
}

CMyString::CMyString(int integer)
{
	isOwnerBuffer = FALSE;
	value = NULL;
	*this=integer;
}

CMyString::CMyString(long linteger)
{
	isOwnerBuffer = FALSE;
	value = NULL;
	*this=linteger;
}

CMyString::CMyString(float floating)
{
	isOwnerBuffer = FALSE;
	value = NULL;
	*this=floating;
}

CMyString::CMyString(double lfloating)
{
	isOwnerBuffer = FALSE;
	value = NULL;
	*this=lfloating;
}

CMyString::CMyString(char *string,BOOL _isOwnerBuffer)
{
	isOwnerBuffer = _isOwnerBuffer;
	value = NULL;
	if (!string) throw CMyException("CMyString","constructor","parameter string is null");
	if (isOwnerBuffer)
	{
		Delete();
		value = string;
		size = (long)strlen(string);
		allocSize = INFINITE;
	}
	else *this=string;
}

CMyString::CMyString(CMyString &string)
{
	isOwnerBuffer = FALSE;
	value = NULL;
	*this=string;
}

// *********************************************************************************

void CMyString::Delete()
{
	if (value!=NULL && !isOwnerBuffer) delete []value;
	size = 0;
	allocSize = 0;
	value = NULL;
}

// *********************************************************************************

CMyString & CMyString::operator=(char letter) // string.operator=(char letter);
{
	Delete();
	size = 1;
	allocSize = 2;
	value = new char[allocSize];
	if (!value) throw CMyExceptionMemory("CMyString","operator=",allocSize);
	value[0]= letter;
	value[1]= '\0';
	return *this; // pour: s=t=u="coucou";
}

CMyString & CMyString::operator=(int integer)
{
	char temp[40];
	sprintf (temp,"%d",integer);
	*this = temp;
	return *this;
}

CMyString & CMyString::operator=(long linteger)
{
	char temp[80];
	sprintf (temp,"%d",linteger);
	*this = temp;
	return *this;
}

CMyString & CMyString::operator=(float floating)
{
	char temp[40];
	sprintf(temp,"%g",floating);
	*this = temp;
	return *this;
}

CMyString & CMyString::operator=(double lfloating)
{
	char temp[40];
	sprintf(temp,"%g",lfloating);
	*this = temp;
	return *this;
}

CMyString & CMyString::operator=(char *string) // string.operator=(char *string);
{
	Delete();
	if (!string) return *this;
	size= (long)strlen(string);
	allocSize = size +1;
	value = new char[allocSize];
	if (!value) throw CMyExceptionMemory("CMyString","operator=(char *)",allocSize);
	strcpy(value,string);
	return *this; // pour: s=t=u="coucou";
}

CMyString & CMyString::operator=(CMyString &string)
{
	Delete();
	if (!string.value) return *this;
	size = string.size;
	allocSize = size +1;
	value = new char[allocSize];
	if (!value) throw CMyExceptionMemory("CMyString","operator=(CMyString &)",allocSize);
	strcpy (value,string.value);
	return *this;
}

// *********************************************************************************

BOOL CMyString::operator==(char letter) 
{
	CMyString temp = letter;
	return !strcmp (value,temp.value);
}

BOOL CMyString::operator==(int integer) 
{
	CMyString temp = integer;
	return !strcmp (value,temp.value);
}

BOOL CMyString::operator==(long linteger) 
{
	CMyString temp = linteger;
	return !strcmp (value,temp.value);
}

BOOL CMyString::operator==(float floating) 
{
	CMyString temp = floating;
	return !strcmp (value,temp.value);
}

BOOL CMyString::operator==(double lfloating) 
{
	CMyString temp = lfloating;
	return !strcmp (value,temp.value);
}

BOOL CMyString::operator==(char *string) 
{
	if (!string) return FALSE;
	return !strcmp (value,string);
}

BOOL CMyString::operator==(CMyString &string)
{
	return !strcmp (value,string.value);
}

// *********************************************************************************

void CMyString::operator+=(char letter) 
{
	// Celle solution n'inserais pas les '\0'
	CMyString temp = letter;
	*this += temp;

	// Cette solution insert le '\0' mais les strcpy ne repsect plus alors le '\0'
	// Resize (size+1,TRUE);
	// value[size]=letter;
	// size+= 1;
}

void CMyString::operator+=(int integer)
{
	CMyString temp = integer;
	*this += temp;
}

void CMyString::operator+=(long linteger)
{
	CMyString temp = linteger;
	*this += temp;
}

void CMyString::operator+=(float floating)
{
	CMyString temp = floating;
	*this += temp;
}

void CMyString::operator+=(double lfloating)
{
	CMyString temp = lfloating;
	*this += temp;
}

void CMyString::operator+=(char *string)
{
	if (!string) { *this; return; }
	if (!value)  *this = ""; 

	long addSize = (long)strlen(string);
	Resize (size+addSize,TRUE);
	strcat (value,string);
	size+= addSize;
}

// *********************************************************************************

CMyString operator+(CMyString &string1,char *string2)
{
	CMyString temp = string1;
	if (!string2) return temp;
	temp += string2;
	return temp;
}

// *********************************************************************************

CMyString operator+(char *string1,CMyString &string2)
{
	CMyString temp;
	if (!string1)
	{
		temp = string2;
		return temp;
	}
	temp = string1;
	temp += string2;
	return temp;
}

// *********************************************************************************

CMyString operator+(CMyString &string,char letter)
{
	CMyString temp = string;
	temp += letter;
	return temp;
}

CMyString operator+(char letter,CMyString &string)
{
	CMyString temp = letter;
	temp += string;
	return temp;
}

CMyString operator+(CMyString &string,int integer)
{
	CMyString temp = string;
	temp += integer;
	return temp;
}

CMyString operator+(int integer,CMyString &string)
{
	CMyString temp = integer;
	temp += string;
	return temp;
}

CMyString operator+(CMyString &string,long linteger)
{
	CMyString temp = string;
	temp += linteger;
	return temp;
}

CMyString operator+(long linteger,CMyString &string)
{
	CMyString temp = linteger;
	temp += string;
	return temp;
}

CMyString operator+(CMyString &string,float floating)
{
	CMyString temp = string;
	temp += floating;
	return temp;
}

CMyString operator+(float floating,CMyString &string)
{
	CMyString temp = floating;
	temp += string;
	return temp;
}

CMyString operator+(CMyString &string,double lfloating)
{
	CMyString temp = string;
	temp += lfloating;
	return temp;
}

CMyString operator+(double lfloating,CMyString &string)
{
	CMyString temp = lfloating;
	temp += string;
	return temp;
}

CMyString operator+(CMyString &string1,CMyString &string2)
{
	CMyString temp = string1;
	temp += string2;
	return temp;
}

/* *********************************************************************************
	Ex.:
	CMyString temp = "coucou";
	if (temp[1]=='o') temp[2]='i';
	// temp == "coicou"
********************************************************************************* */

char &CMyString::operator [] (int index)
{
	static char error='\0';
	index = GetPositionFromLeft(index);
	if (index!=-1) return value[index];
	else return error;
/*
	CMyString temp;
	temp <<"out of bounds: index <> [-"<<size<<";"<<size<<"]";
	throw CMyException("CMyString","operator[](int)",temp);
*/
}

// *********************************************************************************

CMyString & operator << (CMyString& string , char letter)
{
	string += letter;
	return string;
}

CMyString & operator << (CMyString& string , int integer)
{
	string += integer;
	return string;
}

CMyString & operator << (CMyString& string , long linteger)
{
	string += linteger;
	return string;
}

CMyString & operator << (CMyString& string , float floating)
{
	string += floating;
	return string;
}

CMyString & operator << (CMyString& string , double lfloating)
{
	string += lfloating;
	return string;
}

CMyString & operator << (CMyString& string1 , char *string2)
{
	string1 += string2;
	return string1;
}

CMyString & operator << (CMyString& string1 , CMyString &string2)
{
	string1 += string2;
	return string1;
}

// *********************************************************************************

BOOL CMyString::Resize()
{
	return Resize((int)strlen(value),TRUE);
}

// *********************************************************************************

BOOL CMyString::Resize(int newSize,BOOL recopy)
{
	if (newSize<0) newSize=0;
	char *newValue = new char[newSize+1];
	if (!newValue) throw CMyExceptionMemory("CMyString","Resize",newSize+1);
	if (recopy && value) 
	{
		int curSize = min(newSize,allocSize-1);
		strncpy(newValue,value,newSize);
		newValue[curSize]='\0';
		Delete();
		size = curSize;
		allocSize = newSize+1;
	}
	else 
	{
		Delete();
		size = 0;
		allocSize = newSize+1;
		newValue[0]='\0';
	}
	value = newValue;
	return TRUE;
}

/* *********************************************************************************
	Ex.:      "c:\mp3\album\clapton\"
	index deb  1  2   3     4
	index fin  -4 -3  -2    -1

    - ou -

	SubStringBeforToken(-1,result,"\\:") ==> result: "clapton"
********************************************************************************* */

BOOL CMyString::SubStringBeforToken(int numSubString,CMyString &result,char *lstToken)
{
	int indexCur=0;
	int posIndex = size;
	int sizeLstToken = (int)strlen(lstToken);
	int signe = numSubString<0 ? -1 : 1;
	for (int i=numSubString<0;i<size;i++)
	{
		for (int j=0;j<sizeLstToken;j++)
		{
			if (*this[i*size]==lstToken[j])
			{
				indexCur += signe;
				if (indexCur==numSubString)
				{
					posIndex = i-signe;
					CopyTo(result,i+signe,labs(posIndex-i));
					return TRUE;
				}
			}
		}
	}
	return FALSE;
}

// *********************************************************************************

char * CMyString::GetValue(int index)
{
	if (index>=0 && index<size) return value+index;
	if (index<0 && index>=-size) return value+size+index;

	CMyString temp;
	temp <<"out of bounds: index <> [-"<<size<<";"<<size<<"]";
	throw CMyException("CMyString","GetValue[](int)",temp);

}

// *********************************************************************************

BOOL CMyString::CopyTo(CMyString &result,int index,int size)
{
	int signe = index<0 ? -1 : 1;
	char oldLetter = *this[index+size*signe];
	*this[index+size*signe]='\0';
	result.Resize(size);
	result=GetValue(index);
	//result.Resize();
	*this[index+size*signe] = oldLetter;
	return TRUE;
}

// *********************************************************************************

void CMyString::SplitPath(CMyString *drive,CMyString *dir,CMyString *file,CMyString *ext,CMyString *driveDir,CMyString *fileExt)
{
   char _drive[_MAX_DRIVE];
   char _dir[_MAX_DIR];
   char _file[_MAX_FNAME];
   char _ext[_MAX_EXT];

   _splitpath(value,(drive||driveDir)?_drive:NULL,(dir||driveDir)?_dir:NULL,(file||fileExt)?_file:NULL,(ext||fileExt)?_ext:NULL);

   if (drive) *drive=_drive;
   if (dir) *dir=_dir;
   if (file) *file=_file;
   if (ext) *ext=_ext;
   if (fileExt) { *fileExt=""; *fileExt<<_file<<_ext; }
   if (driveDir) { *driveDir=""; *driveDir<<_drive<<_dir; }
}

// *********************************************************************************

long CMyString::ToInteger()
{
	long res;
	sscanf(value,"%d",&res);
	return res;
}

float CMyString::ToFloat()
{
	float res;
	sscanf(value,"%f",&res);
	return res;
}

double CMyString::ToDouble()
{
	double res;
	sscanf(value,"%lf",&res);
	return res;
}

// *********************************************************************************

BOOL CMyString::FormatToNoCtrl()
{
	BOOL isChanged = FALSE;
	CMyString temp;
	for (int i=0;i<size;i++)
	{
		if (value[i]>=32) temp+=value[i];
		else isChanged = TRUE;
	}
	*this=temp;
	return isChanged;
}

// *********************************************************************************

BOOL CMyString::FormatToLower()
{
	BOOL isChanged = FALSE;
	for (int i=0;i<size;i++) 
		if (!islower(value[i]))
		{
			value[i] = tolower(value[i]);
			isChanged = TRUE;
		}
	return isChanged;
}

// *********************************************************************************

BOOL CMyString::FormatToUpper()
{
	BOOL isChanged = FALSE;
	for (int i=0;i<size;i++) 
		if (!isupper(value[i]))
		{
			value[i] = toupper(value[i]);
			isChanged = TRUE;
		}
	return isChanged;
}

// *********************************************************************************

BOOL CMyString::IsVisibleText()
{
	for (int i=0;i<size;i++)
	{
		if (value[i]>32 && value[i]!=255) return TRUE;
	}
	return FALSE;
}

// *********************************************************************************

void CMyString::AddRepetitiveFormat(char *matrise,int nbCopy)
{
	for (int i=0;i<nbCopy;i++)
	{
		operator+=(matrise);
	}
}

/* *********************************************************************************
	Transforme les positons 
	ex.:
	// left count   012
	// right count -321
	CMyString str= "012";
	printf("%d",str.GetPositionFromLeft(1));	// 1
	printf("%d",str.GetPositionFromLeft(-1));	// 2
	printf("%d",str.GetPositionFromRight(1));	// -2
	printf("%d",str.GetPositionFromRight(-1));	// -1
********************************************************************************* */

int CMyString::GetPositionFromLeft(int pos)
{
	pos = pos>=0? pos: size+pos;
	return pos<size? pos : -1;
}

int CMyString::GetPositionFromRight(int pos)
{
	if (pos>=0) return -size+pos;
	else return pos;
}

/* *********************************************************************************
	Efface a partir de la position, avant ou apres d'un certain nombre de caracter 
	ou delimit par un lettre a rechercher
	ex.: 
	CMyString str="0123456";
	str.Delete(-1,FALSE,1); // 012345
	str.Delete(1,TRUE,2);   // 0345
	str.Delete(1,TRUE,'4'); // 05
********************************************************************************* */

BOOL CMyString::Delete(int pos,BOOL after,char letterToFind)
{
	int posLeft = GetPositionFromLeft(pos);
	int posLeft2 = FindLetter(posLeft,after,letterToFind);
	if (posLeft2==-1) return FALSE;
	return Delete(pos,after,abs(posLeft-posLeft2)+1);
}

BOOL CMyString::Delete(int pos,BOOL after,int nbLetter)
{
	int posLeft = GetPositionFromLeft(pos);
	if (!after) posLeft-=nbLetter-1;
	if (value) 
	{
		strncpy(value+posLeft,value+posLeft+nbLetter,size-posLeft-nbLetter);
		return Resize(size-nbLetter,TRUE);
	}
	return FALSE;
}

/* *********************************************************************************
	Ajoute un element a une position donne
	Ex.: 
	CMyString str="012";
	str.Add(1,TRUE,'a'); // 01a2
	str.Add(1,FALSE,-12.2); // 01-12.2a2
	str.Add(-1,TRUE,"coucou"); // 01-12coucou
********************************************************************************* */

BOOL CMyString::Add(int pos,BOOL after,char letter)
{
	CMyString temp;
	int posLeft = GetPositionFromLeft(pos);
	CopyTo(temp,0,posLeft+!after);
	temp<<letter;
	temp<<value+posLeft+!after+1;
	operator=(temp);
	return TRUE;
}

BOOL CMyString::Add(int pos,BOOL after,int integer)
{
	return TRUE;
}
BOOL CMyString::Add(int pos,BOOL after,long linteger)
{
	return TRUE;
}
BOOL CMyString::Add(int pos,BOOL after,float floating)
{
	return TRUE;
}
BOOL CMyString::Add(int pos,BOOL after,double lfloating)
{
	return TRUE;
}
BOOL CMyString::Add(int pos,BOOL after,char *string)
{
	return TRUE;
}
BOOL CMyString::Add(int pos,BOOL after,CMyString &string)
{
	return TRUE;
}

/* *********************************************************************************
	Donne la position d'un lettre a partir de la pos de base dansla direction after
	avec comme model la letter
	retourne -1 si pas de model trouv
********************************************************************************* */

int CMyString::FindLetter(int pos,BOOL after,char letter)
{
	int posLeft = GetPositionFromLeft(pos);

	if (after)
	{
		for (int i=posLeft;i<size;i++)
			if (value[i]==letter) return i;
	}
	else
	{
		for (int i=posLeft;i>=0;i--)
			if (value[i]==letter) return i;
	}
	return -1;
}