#ifndef INCLUDE_MYSTRING_H
#define INCLUDE_MYSTRING_H

#include <windef.h>
/* --------------------------------------------------------------- 
	Ex de test!
	CMyString temp,a,b,c;

	a = "coucou";
	b = "toi";
	c = a;
	temp = a + "lui";
	c = "hello " + b;
	temp = a + b;
--------------------------------------------------------------- */

class CMyString
{
	public:
		CMyString();
		virtual ~CMyString() { Delete(); }

		void Delete();
		BOOL Resize();
		BOOL Resize(int newSize,BOOL recopy=FALSE);
		BOOL IsEmpty() { return size == 0; }

		CMyString(char letter);
		CMyString(int integer);
		CMyString(long linteger);
		CMyString(float floating);
		CMyString(double lfloating);
		CMyString(char *string,BOOL isOwnerBuffer=FALSE);
		CMyString(CMyString &string);

		void operator+=(char letter);
		void operator+=(int integer);
		void operator+=(long linteger);
		void operator+=(float floating);
		void operator+=(double lfloating);
		void operator+=(char *string);
		void operator+=(CMyString &string) { *this+=string.value; }

		CMyString & operator=(char letter);
		CMyString & operator=(int integer);
		CMyString & operator=(long linteger);
		CMyString & operator=(float floating);
		CMyString & operator=(double lfloating);
		CMyString & operator=(char *string);
		CMyString & operator=(CMyString &string);

		BOOL operator==(char letter);
		BOOL operator==(int integer);
		BOOL operator==(long linteger);
		BOOL operator==(float floating);
		BOOL operator==(double lfloating);
		BOOL operator==(char *string);
		BOOL operator==(CMyString &string);

		BOOL operator!=(char letter) { return !operator==(letter); };
		BOOL operator!=(int integer) { return !operator==(integer); };
		BOOL operator!=(long linteger) { return !operator==(linteger); };
		BOOL operator!=(float floating) { return !operator==(floating); };
		BOOL operator!=(double lfloating) { return !operator==(lfloating); };
		BOOL operator!=(char *string) { return !operator==(string); };
		BOOL operator!=(CMyString &string) { return !operator==(string); };

		long	ToInteger();
		float	ToFloat();
		double	ToDouble();


		friend CMyString operator+(CMyString &string,char letter);
		friend CMyString operator+(char letter,CMyString &string);

		friend CMyString operator+(CMyString &string,int integer);
		friend CMyString operator+(int integer,CMyString &string);

		friend CMyString operator+(CMyString &string,long linteger);
		friend CMyString operator+(long linteger,CMyString &string);

		friend CMyString operator+(CMyString &string,float floating);
		friend CMyString operator+(float floating,CMyString &string);

		friend CMyString operator+(CMyString &string,double lfloating);
		friend CMyString operator+(double lfloating,CMyString &string);

		friend CMyString operator+(CMyString &string1,char *string2);
		friend CMyString operator+(char *string1,CMyString &string2);

		friend CMyString operator+(CMyString &string1,CMyString &string2);

		char & operator [] (int num);
		operator char *() const { return value; }

		friend CMyString & operator << (CMyString& string , char letter);
		friend CMyString & operator << (CMyString& string , int integer);
		friend CMyString & operator << (CMyString& string , long linteger);
		friend CMyString & operator << (CMyString& string , float floating);
		friend CMyString & operator << (CMyString& string , double lfloating);
		friend CMyString & operator << (CMyString& string1 , char *string2);
		friend CMyString & operator << (CMyString& string1 , CMyString &string2);

		void SplitPath(CMyString *drive,CMyString *dir,CMyString *file,CMyString *ext,CMyString *driveDir,CMyString *fileExt);
		BOOL SubStringBeforToken(int numSubString,CMyString &result,char *lstToken);

		char * GetValue(int index);
		BOOL CopyTo(CMyString &result,int index,int size);

		BOOL FormatToNoCtrl();
		BOOL FormatToLower();
		BOOL FormatToUpper();

		void AddRepetitiveFormat(char *matrise,int nbCopy);
		
		BOOL IsVisibleText();

		int GetPositionFromLeft(int pos);
		int GetPositionFromRight(int pos);

		BOOL Delete(int pos,BOOL after,char letterToFind);
		BOOL Delete(int pos,BOOL after,int nbLetter);

		BOOL Add(int pos,BOOL after,char letter);
		BOOL Add(int pos,BOOL after,int integer);
		BOOL Add(int pos,BOOL after,long linteger);
		BOOL Add(int pos,BOOL after,float floating);
		BOOL Add(int pos,BOOL after,double lfloating);
		BOOL Add(int pos,BOOL after,char *string);
		BOOL Add(int pos,BOOL after,CMyString &string);
		
		int FindLetter(int pos,BOOL after,char letter);
	public:
		char *value;
		long size;

	private:
		BOOL isOwnerBuffer;
		long allocSize;
};

#endif