#include "stdafx.h"
#include <commctrl.h> // pour InitCommonControls
#include <windowsx.h> // pour les Edit_SetText et autre ...
#include "analyse.h"
#include "resource.h"

HINSTANCE hInst;

LRESULT CALLBACK MainProc (HWND , UINT , WPARAM , LPARAM );

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	hInst = hInstance;
	LoadLibrary("riched32.dll");
	InitCommonControls(); // ajouter "comctl32.lib" dans les settings
	DialogBox(hInstance,MAKEINTRESOURCE(IDD_DIALOG_MAIN),NULL,(DLGPROC) MainProc);
	return TRUE;
}

class CGetDlgItem
{
	private:
		HWND hWnd;

	public:
		CGetDlgItem(HWND _hWnd)
		{
			hWnd=_hWnd;
		}

		HWND Get (long id)
		{
			return GetDlgItem(hWnd,id);
		}
};

#include "MyImageList.h"

LRESULT CALLBACK MainProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static char file1[MAX_PATH];
	static char file2[MAX_PATH];
	static char temp[MAX_PATH];
	static long size;
	static CMyString str;

	static CMyListView *lstSyntetic,*lstIndex,*lstModele;
	static CGetDlgItem hWnd(hDlg);
	static CMyProgress *progress;
	static CLstModele modele(hDlg);
	static BOOL endFind;

	static CMyImageList *il;
	switch (message)
	{
		case WM_INITDIALOG:
			{
				//il = new CMyImageList(16,16,ILC_COLOR16,1,1);
				//il->LoadImage(hInst,MAKEINTRESOURCE(IDI_ICON_SIMPLE),16,1,CLR_DEFAULT,IMAGE_ICON,LR_DEFAULTCOLOR);

				CMyRegistre reg("headerAnalyse");
				reg.GetValue("file1",file1);
				reg.GetValue("file2",file2);
				reg.GetValue("size",&size);
				reg.GetValue("endFind",(long *)&endFind);

				Edit_SetText(hWnd.Get(IDC_EDIT_FILE1),file1);
				Edit_SetText(hWnd.Get(IDC_EDIT_FILE2),file2);
				str=size;
				Edit_SetText(hWnd.Get(IDC_EDIT_SIZE),str);
			}

			lstSyntetic = new CMyListView(hWnd.Get(IDC_LIST_SYNTETIC));
			lstSyntetic->AddColumnPercent("Modele(text)",0.2);
			lstSyntetic->AddColumnPercent("Modele(code)",0.3);
			lstSyntetic->AddColumnPercent("index file1",0.25);
			lstSyntetic->AddColumnPercent("index file2",0.25);

			lstIndex = new CMyListView(hWnd.Get(IDC_LIST_INDEX));
			lstIndex->AddColumnPercent("file1",0.5);
			lstIndex->AddColumnPercent("file2",0.5);
			
			lstModele = new CMyListView(hWnd.Get(IDC_LIST_MODELE));
			lstModele->SetGridLinesView(TRUE);
			int i;
			for (i=0;i<10;i++) lstModele->AddColumnPercent("",0.07);
			lstModele->AddColumnPercent("",0.3);

			progress = new CMyProgress(hWnd.Get(IDC_PROGRESS));
			progress->Set(0,"<Push \"Compute\">");
			return TRUE;

		case WM_COMMAND:
			TListModele modeleCur;
			int line;
			int column;
			ENotify res;
			switch (LOWORD(wParam))
			{
				case IDOK:
				case IDCANCEL:
					{
						CMyRegistre reg("headerAnalyse");
						reg.SetValue("file1",file1);
						reg.SetValue("file2",file2);
						reg.SetValue("size",size);
						reg.SetValue("endFind",endFind);

					}
					EndDialog(hDlg, LOWORD(wParam));
					return TRUE;

				case IDC_BUTTON_COMPUTE:
					Edit_GetText(GetDlgItem(hDlg,IDC_EDIT_FILE1),file1,MAX_PATH);
					Edit_GetText(GetDlgItem(hDlg,IDC_EDIT_FILE2),file2,MAX_PATH);
					Edit_GetText(GetDlgItem(hDlg,IDC_EDIT_SIZE),temp,MAX_PATH);
					sscanf(temp,"%d",&size);
					endFind = Button_GetCheck(hWnd.Get(IDC_CHECK_ENDFIND));

					lstModele->Enable(FALSE);
					lstSyntetic->Enable(FALSE);
					lstIndex->Enable(FALSE);
					Button_Enable(hWnd.Get(IDC_BUTTON_COMPUTE),FALSE);

					if (!modele.Analyse(file1,file2,size,progress,endFind)) progress->Set(0,"!Error configuration");
					return TRUE;

				case PERSO_END_ANALYSE:
					Button_Enable(hWnd.Get(IDC_BUTTON_COMPUTE),TRUE);
					lstModele->Enable(TRUE);
					lstSyntetic->Enable(TRUE);
					lstIndex->Enable(TRUE);
					lstSyntetic->SetNbCount(modele.list.GetNbElem());
					return TRUE;

				case IDC_BUTTON_FILE1:
					{
						CMyBrowseFile browse(hDlg,"Select file:",TYPE_FILE_OPEN,"All Files (*.*)\0*.*\0\0",NULL);
						browse.GetResult(file1);
						Edit_SetText(hWnd.Get(IDC_EDIT_FILE1),file1);
					}
					return TRUE;

				case IDC_BUTTON_FILE2:
					{
						CMyBrowseFile browse(hDlg,"Select file:",TYPE_FILE_OPEN,"All Files (*.*)\0*.*\0\0",NULL);
						browse.GetResult(file2);
						Edit_SetText(hWnd.Get(IDC_EDIT_FILE2),file2);
					}
					return TRUE;
					
				case IDC_LIST_SYNTETIC:
					res = (ENotify) lParam;
					line = lstSyntetic->GetLine();
					column = lstSyntetic->GetColumn();
					if (line>=modele.list.GetNbElem()) return TRUE;
					modeleCur = modele.list[line];
					switch (res)
					{
						case getDispInfo:
							{
								switch (column)
								{
									case 0: // Modele(text)
										str = "";
										modeleCur.elem.ExtractText(str);
										lstSyntetic->SetItemText(str);
										return TRUE;
									case 1: // Modele(code)
										str = "";
										modeleCur.elem.ExtractCode(str);
										lstSyntetic->SetItemText(str);
										return TRUE;
									case 2: // list1
										str = "";
										modeleCur.lstBuffer1.Extract(str);
										lstSyntetic->SetItemText(str);
										return TRUE;
									case 3: // list2
										str = "";
										modeleCur.lstBuffer2.Extract(str);
										lstSyntetic->SetItemText(str);
										return TRUE;
								}
							}	
							return TRUE;

						case itemChanged:
							modeleCur = modele.list[lstSyntetic->GetLineSelected()];
							lstIndex->SetNbCount(max(modeleCur.lstBuffer1.lstBuffer.GetNbElem(),modeleCur.lstBuffer2.lstBuffer.GetNbElem()));
							lstIndex->Refresh();
							str="";
							str<<"Index list: ("<<modeleCur.nbSame<<" same)";
							Static_SetText(hWnd.Get(IDC_STATIC_INDEX),str);
							str="";
							str<<"File1 ("<<modeleCur.lstBuffer1.lstBuffer.GetNbElem()<<")";
							lstIndex->SetColumn(0,str);
							str="";
							str<<"File2 ("<<modeleCur.lstBuffer2.lstBuffer.GetNbElem()<<")";
							lstIndex->SetColumn(1,str);

							lstModele->SetNbCount(modeleCur.elem.size/10+1);
							lstModele->Refresh();
							str="";
							str<<"Modele view: ("<<modeleCur.elem.size<<" bytes)";
							Static_SetText(hWnd.Get(IDC_STATIC_MODELE),str);

							return TRUE;
					}
					break;

				case IDC_LIST_INDEX:
					res = (ENotify) lParam;
					line = lstSyntetic->GetLineSelected();
					if (line>=modele.list.GetNbElem()) return TRUE;					
					modeleCur = modele.list[line];
					line = lstIndex->GetLine();
					column = lstIndex->GetColumn();
					switch (res)
					{
						case getDispInfo:
							{
								long index;
								switch (column)
								{
									case 0: // List fichier 1
										if (line>=modeleCur.lstBuffer1.lstBuffer.GetNbElem()) return TRUE;
										index = modeleCur.lstBuffer1.lstBuffer[line];
										str = index;
										lstIndex->SetItemText(str);		
										return TRUE;
										
									case 1: // List fichier 2
										if (line>=modeleCur.lstBuffer2.lstBuffer.GetNbElem()) return TRUE;
										index = modeleCur.lstBuffer2.lstBuffer[line];
										str = index;
										lstIndex->SetItemText(str);
										return TRUE;
								}
							}	
							return TRUE;
					}
					break;

				case IDC_LIST_MODELE:
					res = (ENotify) lParam;
					line = lstSyntetic->GetLineSelected();
					if (line>=modele.list.GetNbElem()) return TRUE;					
					modeleCur = modele.list[line];
					line = lstModele->GetLine();
					column = lstModele->GetColumn();
					switch (res)
					{
						case getDispInfo:
							{
								long index = column==10 ? line*10 : line*10+column;
								if (column==10)
								{
									str ="";
									modeleCur.elem.ExtractText(str,10,index);
								}
								else
								{
									if (index>=modeleCur.elem.size) return TRUE;
									str = modeleCur.elem.buffer[index];
								}
								lstModele->SetItemText(str);
							}	
							return TRUE;
					}
					break;


			}
			break;
	}
    return FALSE;
}
